<script src="@#file#(bresenham.js)" type="text/javascript"></script>

<p>Sada ćemo pogledati kako se riješiti potrebe za zaokruživanjem u petlji. Umjesto da računamo decimalne vrijednosti koordinate y, iste ćemo držati cjelobrojnima, a pratit ćemo koliko je ta cjelobrojna vrijednost udaljena od idealne kroz koju prolaz linija. U trenutku kada pogreška dođe do 0.5 ili preko toga, povećat ćemo y te korigirati pogrešku. Primijetimo, pomicanjem po x-osi za 1, y-koordinata bi trebala porasti za koeficijent \(a\), pa ako y ne diramo, to je upravo iznos za koji će porasti pogreška. S druge strane, jednom kad pogreška pređe 0.5 pa povećamo y, nova vrijednost sada je iznad pravca pa je odstupanje linije od slikovnog elementa koji ćemo osvijetliti jednako trenutnoj pogrešci umanjenoj za 1 (postat će negativno).</p>

<p>Evo algoritma.</p>

<pre>
void drawLine(int xs, int ys, int xe, int ye) {
  int x, yc;
  double a, yf;
  a = (ye−ys)/(double)(xe−xs);
  yc=ys; yf = 0.0;
  for(x=xs; x&lt;=xe; x++) {
    osvijetli_pixel(x, yc);
    yf = yf+a;
    if(yf&gt;=0.5) {
      yf=yf-1.0;
      yc=yc+1;
    }
  }
}
</pre>

<p>Varijabla <code>yf</code> prati trenutnu pogrešku i uz koeficijent smjera, to je jedina decimalna varijabla.</p>

  <div width="500" height="500" style="position:relative;">
  <canvas id="myCanvas3" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var lineData3 = {x0: 1, y0: 1, x1: 17, y1: 8};
    var brcanvas3 = new RasterDisplay("myCanvas3", 20, 20);
    var alg3 = new BresenhamAlgorithm3(lineData3, brcanvas3);
    brcanvas3.idealLineData = lineData3;
    brcanvas3.paint();
  </script>
  drawLine(<input type="text" id="line3_x0" value="1" size="2">, <input type="text" id="line3_y0" value="1" size="2">, <input type="text" id="line3_x1" value="17" size="2">, <input type="text" id="line3_y1" value="8" size="2">)
  <button onclick="if(parseLineData('line3',lineData3)) {alg3.reset(); document.getElementById('alg3btn').disabled=false;}">Postavi</button><br>
  <button onclick="alg3.reset(); document.getElementById('alg3btn').disabled=false;">Reset</button>
  <button id="alg3btn" onclick="alg3.next(); if(!alg3.hasNext()) this.disabled=true;">Korak</button>
  <input id="alg3ch1" type="checkbox" onclick="brcanvas3.showIdealLine = document.getElementById('alg3ch1').checked ? true : false; brcanvas3.paint();"> Prikaz idealne linije

  <p>Isprobajte nacrtati sljedeće linije ovim algoritmom:</p>
  <ol>
    <li>drawLine(1,1,17,8): kut je između 0° i 45°</li>
    <li>drawLine(1,8,17,1): kut je između -45° i 0°</li>
    <li>drawLine(1,1,8,17): kut je između 45° i 90°</li>
    <li>drawLine(8,17,1,1): x-koordinata se smanjuje</li>
  </ol>
  <p>Uz ovakvu implementaciju dobivamo specifično ponašanje za slučajeve 2 i 3.
     Isprobajte ih. Razumijete li zašto dobivamo prikazanu sliku?</p>
  <p>Možete li objasniti ponašanje algoritma za slučaj 4?</p>

<p>Kao mali korak u povećanju učinkovitosti radi se još jedna korekcija. Inicijalna vrijednost pogreške postavlja se na -0.5 pa je u petlji dovoljno provjeriti predznak pogreške a ne i magnitudu, što se može obaviti puno brže. Ovakva modifikacija prikazana je u nastavku.</p>

<pre>
void drawLine(int xs, int ys, int xe, int ye) {
  int x, yc;
  double a, yf;
  a = (ye−ys)/(double)(xe−xs);
  yc=ys; yf = -0.5;
  for(x=xs; x&lt;=xe; x++) {
    osvijetli_pixel(x, yc);
    yf = yf+a;
    if(yf&gt;=0.0) {
      yf=yf-1.0;
      yc=yc+1;
    }
  }
}
</pre>

